<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PassengerType StructType
 * @subpackage Structs
 */
class PassengerType extends AbstractStructBase
{
    /**
     * The Passenger
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\PersonType
     */
    public $Passenger;
    /**
     * The TravellerType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $TravellerType;
    /**
     * The LoyaltyNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LoyaltyNumber;
    /**
     * The LoyaltyType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LoyaltyType;
    /**
     * The LoyaltyTier
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $LoyaltyTier;
    /**
     * Constructor method for PassengerType
     * @uses PassengerType::setPassenger()
     * @uses PassengerType::setTravellerType()
     * @uses PassengerType::setLoyaltyNumber()
     * @uses PassengerType::setLoyaltyType()
     * @uses PassengerType::setLoyaltyTier()
     * @param \StructType\PersonType $passenger
     * @param string $travellerType
     * @param string $loyaltyNumber
     * @param string $loyaltyType
     * @param int $loyaltyTier
     */
    public function __construct(\StructType\PersonType $passenger = null, $travellerType = null, $loyaltyNumber = null, $loyaltyType = null, $loyaltyTier = null)
    {
        $this
            ->setPassenger($passenger)
            ->setTravellerType($travellerType)
            ->setLoyaltyNumber($loyaltyNumber)
            ->setLoyaltyType($loyaltyType)
            ->setLoyaltyTier($loyaltyTier);
    }
    /**
     * Get Passenger value
     * @return \StructType\PersonType
     */
    public function getPassenger()
    {
        return $this->Passenger;
    }
    /**
     * Set Passenger value
     * @param \StructType\PersonType $passenger
     * @return \StructType\PassengerType
     */
    public function setPassenger(\StructType\PersonType $passenger = null)
    {
        $this->Passenger = $passenger;
        return $this;
    }
    /**
     * Get TravellerType value
     * @return string
     */
    public function getTravellerType()
    {
        return $this->TravellerType;
    }
    /**
     * Set TravellerType value
     * @uses \EnumType\TravellerType::valueIsValid()
     * @uses \EnumType\TravellerType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $travellerType
     * @return \StructType\PassengerType
     */
    public function setTravellerType($travellerType = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\TravellerType::valueIsValid($travellerType)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $travellerType, implode(', ', \EnumType\TravellerType::getValidValues())), __LINE__);
        }
        $this->TravellerType = $travellerType;
        return $this;
    }
    /**
     * Get LoyaltyNumber value
     * @return string|null
     */
    public function getLoyaltyNumber()
    {
        return $this->LoyaltyNumber;
    }
    /**
     * Set LoyaltyNumber value
     * @param string $loyaltyNumber
     * @return \StructType\PassengerType
     */
    public function setLoyaltyNumber($loyaltyNumber = null)
    {
        // validation for constraint: string
        if (!is_null($loyaltyNumber) && !is_string($loyaltyNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($loyaltyNumber)), __LINE__);
        }
        $this->LoyaltyNumber = $loyaltyNumber;
        return $this;
    }
    /**
     * Get LoyaltyType value
     * @return string|null
     */
    public function getLoyaltyType()
    {
        return $this->LoyaltyType;
    }
    /**
     * Set LoyaltyType value
     * @param string $loyaltyType
     * @return \StructType\PassengerType
     */
    public function setLoyaltyType($loyaltyType = null)
    {
        // validation for constraint: string
        if (!is_null($loyaltyType) && !is_string($loyaltyType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($loyaltyType)), __LINE__);
        }
        $this->LoyaltyType = $loyaltyType;
        return $this;
    }
    /**
     * Get LoyaltyTier value
     * @return int|null
     */
    public function getLoyaltyTier()
    {
        return $this->LoyaltyTier;
    }
    /**
     * Set LoyaltyTier value
     * @param int $loyaltyTier
     * @return \StructType\PassengerType
     */
    public function setLoyaltyTier($loyaltyTier = null)
    {
        // validation for constraint: int
        if (!is_null($loyaltyTier) && !is_numeric($loyaltyTier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($loyaltyTier)), __LINE__);
        }
        $this->LoyaltyTier = $loyaltyTier;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PassengerType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
