<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PingResponse StructType
 * @subpackage Structs
 */
class PingResponse extends AbstractStructBase
{
    /**
     * The PingFields
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\KeyValueType[]
     */
    public $PingFields;
    /**
     * The UserDefinedFields
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\KeyValueType[]
     */
    public $UserDefinedFields;
    /**
     * Constructor method for PingResponse
     * @uses PingResponse::setPingFields()
     * @uses PingResponse::setUserDefinedFields()
     * @param \StructType\KeyValueType[] $pingFields
     * @param \StructType\KeyValueType[] $userDefinedFields
     */
    public function __construct(array $pingFields = array(), array $userDefinedFields = array())
    {
        $this
            ->setPingFields($pingFields)
            ->setUserDefinedFields($userDefinedFields);
    }
    /**
     * Get PingFields value
     * @return \StructType\KeyValueType[]|null
     */
    public function getPingFields()
    {
        return $this->PingFields;
    }
    /**
     * Set PingFields value
     * @throws \InvalidArgumentException
     * @param \StructType\KeyValueType[] $pingFields
     * @return \StructType\PingResponse
     */
    public function setPingFields(array $pingFields = array())
    {
        foreach ($pingFields as $pingResponsePingFieldsItem) {
            // validation for constraint: itemType
            if (!$pingResponsePingFieldsItem instanceof \StructType\KeyValueType) {
                throw new \InvalidArgumentException(sprintf('The PingFields property can only contain items of \StructType\KeyValueType, "%s" given', is_object($pingResponsePingFieldsItem) ? get_class($pingResponsePingFieldsItem) : gettype($pingResponsePingFieldsItem)), __LINE__);
            }
        }
        $this->PingFields = $pingFields;
        return $this;
    }
    /**
     * Add item to PingFields value
     * @throws \InvalidArgumentException
     * @param \StructType\KeyValueType $item
     * @return \StructType\PingResponse
     */
    public function addToPingFields(\StructType\KeyValueType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KeyValueType) {
            throw new \InvalidArgumentException(sprintf('The PingFields property can only contain items of \StructType\KeyValueType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PingFields[] = $item;
        return $this;
    }
    /**
     * Get UserDefinedFields value
     * @return \StructType\KeyValueType[]|null
     */
    public function getUserDefinedFields()
    {
        return $this->UserDefinedFields;
    }
    /**
     * Set UserDefinedFields value
     * @throws \InvalidArgumentException
     * @param \StructType\KeyValueType[] $userDefinedFields
     * @return \StructType\PingResponse
     */
    public function setUserDefinedFields(array $userDefinedFields = array())
    {
        foreach ($userDefinedFields as $pingResponseUserDefinedFieldsItem) {
            // validation for constraint: itemType
            if (!$pingResponseUserDefinedFieldsItem instanceof \StructType\KeyValueType) {
                throw new \InvalidArgumentException(sprintf('The UserDefinedFields property can only contain items of \StructType\KeyValueType, "%s" given', is_object($pingResponseUserDefinedFieldsItem) ? get_class($pingResponseUserDefinedFieldsItem) : gettype($pingResponseUserDefinedFieldsItem)), __LINE__);
            }
        }
        $this->UserDefinedFields = $userDefinedFields;
        return $this;
    }
    /**
     * Add item to UserDefinedFields value
     * @throws \InvalidArgumentException
     * @param \StructType\KeyValueType $item
     * @return \StructType\PingResponse
     */
    public function addToUserDefinedFields(\StructType\KeyValueType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KeyValueType) {
            throw new \InvalidArgumentException(sprintf('The UserDefinedFields property can only contain items of \StructType\KeyValueType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UserDefinedFields[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PingResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
